Index: kern/vfs_subr.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_subr.c,v
retrieving revision 1.25
diff -u -r1.25 vfs_subr.c
--- kern/vfs_subr.c	10 Feb 2004 07:34:42 -0000	1.25
+++ kern/vfs_subr.c	24 Feb 2004 19:00:44 -0000
@@ -2356,14 +2487,14 @@
 		return (SYSCTL_OUT(req, 0,
 			(numvnodes + KINFO_VNODESLOP) * (VPTRSZ + VNODESZ)));
 
-	lwkt_gettoken(&mountlist_token);
+	lwkt_gettoken(&ilock, &mountlist_token);
 	for (mp = TAILQ_FIRST(&mountlist); mp != NULL; mp = nmp) {
-		if (vfs_busy(mp, LK_NOWAIT, &mountlist_token, p)) {
+		if (vfs_busy(mp, LK_NOWAIT, &ilock, p)) {
 			nmp = TAILQ_NEXT(mp, mnt_list);
 			continue;
 		}
+		lwkt_gettoken(&jlock, &mntvnode_token);
 again:
-		lwkt_gettoken(&mntvnode_token);
 		for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist);
 		     vp != NULL;
 		     vp = nvp) {
@@ -2372,23 +2503,21 @@
 			 * this filesystem.  RACE: could have been
 			 * recycled onto the same filesystem.
 			 */
-			if (vp->v_mount != mp) {
-				lwkt_reltoken(&mntvnode_token);
+			if (vp->v_mount != mp)
 				goto again;
-			}
 			nvp = TAILQ_NEXT(vp, v_nmntvnodes);
-			lwkt_reltoken(&mntvnode_token);
 			if ((error = SYSCTL_OUT(req, &vp, VPTRSZ)) ||
-			    (error = SYSCTL_OUT(req, vp, VNODESZ)))
+			    (error = SYSCTL_OUT(req, vp, VNODESZ))) {
+				lwkt_reltoken(&jlock);
 				return (error);
-			lwkt_gettoken(&mntvnode_token);
+			}
 		}
-		lwkt_reltoken(&mntvnode_token);
-		lwkt_gettoken(&mountlist_token);
-		nmp = TAILQ_NEXT(mp, mnt_list);
+		lwkt_reltoken(&jlock);
+		lwkt_gettokref(&ilock);
+		nmp = TAILQ_NEXT(mp, mnt_list);	/* ZZZ */
 		vfs_unbusy(mp, p);
 	}
-	lwkt_reltoken(&mountlist_token);
+	lwkt_reltoken(&ilock);
 
 	return (0);
 }
@@ -2720,10 +2849,11 @@
 	struct thread *td = curthread;	/* XXX */
 	struct vnode *vp, *nvp;
 	struct vm_object *obj;
+	lwkt_tokref ilock;
 	int tries;
 
 	tries = 5;
-	lwkt_gettoken(&mntvnode_token);
+	lwkt_gettoken(&ilock, &mntvnode_token);
 loop:
 	for (vp = TAILQ_FIRST(&mp->mnt_nvnodelist); vp != NULL; vp = nvp) {
 		if (vp->v_mount != mp) {
@@ -2743,15 +2873,13 @@
 		 */
 		if ((vp->v_flag & VOBJDIRTY) &&
 		    (flags == MNT_WAIT || VOP_ISLOCKED(vp, NULL) == 0)) {
-			lwkt_reltoken(&mntvnode_token);
-			if (!vget(vp,
+			if (!vget(vp, NULL,
 			    LK_EXCLUSIVE | LK_RETRY | LK_NOOBJ, td)) {
 				if (VOP_GETVOBJECT(vp, &obj) == 0) {
 					vm_object_page_clean(obj, 0, 0, flags == MNT_WAIT ? OBJPC_SYNC : OBJPC_NOSYNC);
 				}
 				vput(vp);
 			}
-			lwkt_gettoken(&mntvnode_token);
 			if (TAILQ_NEXT(vp, v_nmntvnodes) != nvp) {
 				if (--tries > 0)
 					goto loop;
@@ -2759,7 +2887,7 @@
 			}
 		}
 	}
-	lwkt_reltoken(&mntvnode_token);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -2777,13 +2905,13 @@
 }
 
 void
-vfree(vp)
-	struct vnode *vp;
+vfree(struct vnode *vp)
 {
+	lwkt_tokref ilock;
 	int s;
 
 	s = splbio();
-	lwkt_gettoken(&vnode_free_list_token);
+	lwkt_gettoken(&ilock, &vnode_free_list_token);
 	KASSERT((vp->v_flag & VFREE) == 0, ("vnode already free"));
 	if (vp->v_flag & VAGE) {
 		TAILQ_INSERT_HEAD(&vnode_free_list, vp, v_freelist);
@@ -2791,7 +2919,7 @@
 		TAILQ_INSERT_TAIL(&vnode_free_list, vp, v_freelist);
 	}
 	freevnodes++;
-	lwkt_reltoken(&vnode_free_list_token);
+	lwkt_reltoken(&ilock);
 	vp->v_flag &= ~VAGE;
 	vp->v_flag |= VFREE;
 	splx(s);
@@ -2801,14 +2929,15 @@
 vbusy(vp)
 	struct vnode *vp;
 {
+	lwkt_tokref ilock;
 	int s;
 
 	s = splbio();
-	lwkt_gettoken(&vnode_free_list_token);
+	lwkt_gettoken(&ilock, &vnode_free_list_token);
 	KASSERT((vp->v_flag & VFREE) != 0, ("vnode not free"));
 	TAILQ_REMOVE(&vnode_free_list, vp, v_freelist);
 	freevnodes--;
-	lwkt_reltoken(&vnode_free_list_token);
+	lwkt_reltoken(&ilock);
 	vp->v_flag &= ~(VFREE|VAGE);
 	splx(s);
 }
@@ -2824,7 +2953,9 @@
 int
 vn_pollrecord(struct vnode *vp, struct thread *td, int events)
 {
-	lwkt_gettoken(&vp->v_pollinfo.vpi_token);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &vp->v_pollinfo.vpi_token);
 	if (vp->v_pollinfo.vpi_revents & events) {
 		/*
 		 * This leaves events we are not interested
@@ -2836,12 +2967,12 @@
 		events &= vp->v_pollinfo.vpi_revents;
 		vp->v_pollinfo.vpi_revents &= ~events;
 
-		lwkt_reltoken(&vp->v_pollinfo.vpi_token);
+		lwkt_reltoken(&ilock);
 		return events;
 	}
 	vp->v_pollinfo.vpi_events |= events;
 	selrecord(td, &vp->v_pollinfo.vpi_selinfo);
-	lwkt_reltoken(&vp->v_pollinfo.vpi_token);
+	lwkt_reltoken(&ilock);
 	return 0;
 }
 
@@ -2856,7 +2987,9 @@
 	struct vnode *vp;
 	short events;
 {
-	lwkt_gettoken(&vp->v_pollinfo.vpi_token);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &vp->v_pollinfo.vpi_token);
 	if (vp->v_pollinfo.vpi_events & events) {
 		/*
 		 * We clear vpi_events so that we don't
@@ -2873,7 +3006,7 @@
 		vp->v_pollinfo.vpi_revents |= events;
 		selwakeup(&vp->v_pollinfo.vpi_selinfo);
 	}
-	lwkt_reltoken(&vp->v_pollinfo.vpi_token);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -2885,12 +3018,14 @@
 vn_pollgone(vp)
 	struct vnode *vp;
 {
-	lwkt_gettoken(&vp->v_pollinfo.vpi_token);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &vp->v_pollinfo.vpi_token);
 	if (vp->v_pollinfo.vpi_events) {
 		vp->v_pollinfo.vpi_events = 0;
 		selwakeup(&vp->v_pollinfo.vpi_selinfo);
 	}
-	lwkt_reltoken(&vp->v_pollinfo.vpi_token);
+	lwkt_reltoken(&ilock);
 }
 
 
@@ -2978,6 +3113,7 @@
 	struct vnode *syncvp = ap->a_vp;
 	struct mount *mp = syncvp->v_mount;
 	struct thread *td = ap->a_td;
+	lwkt_tokref ilock;
 	int asyncflag;
 
 	/*
@@ -2995,9 +3131,9 @@
 	 * Walk the list of vnodes pushing all that are dirty and
 	 * not already on the sync list.
 	 */
-	lwkt_gettoken(&mountlist_token);
-	if (vfs_busy(mp, LK_EXCLUSIVE | LK_NOWAIT, &mountlist_token, td) != 0) {
-		lwkt_reltoken(&mountlist_token);
+	lwkt_gettoken(&ilock, &mountlist_token);
+	if (vfs_busy(mp, LK_EXCLUSIVE | LK_NOWAIT, &ilock, td) != 0) {
+		lwkt_reltoken(&ilock);
 		return (0);
 	}
 	asyncflag = mp->mnt_flag & MNT_ASYNC;
@@ -3138,7 +3274,7 @@
 	if (!(flags & NDF_NO_DVP_UNLOCK) &&
 	    (ndp->ni_cnd.cn_flags & CNP_LOCKPARENT) &&
 	    ndp->ni_dvp != ndp->ni_vp) {
-		VOP_UNLOCK(ndp->ni_dvp, 0, ndp->ni_cnd.cn_td);
+		VOP_UNLOCK(ndp->ni_dvp, NULL, 0, ndp->ni_cnd.cn_td);
 	}
 	if (!(flags & NDF_NO_DVP_RELE) &&
 	    (ndp->ni_cnd.cn_flags & (CNP_LOCKPARENT|CNP_WANTPARENT))) {
@@ -3147,7 +3283,7 @@
 	}
 	if (!(flags & NDF_NO_VP_UNLOCK) &&
 	    (ndp->ni_cnd.cn_flags & CNP_LOCKLEAF) && ndp->ni_vp) {
-		VOP_UNLOCK(ndp->ni_vp, 0, ndp->ni_cnd.cn_td);
+		VOP_UNLOCK(ndp->ni_vp, NULL, 0, ndp->ni_cnd.cn_td);
 	}
 	if (!(flags & NDF_NO_VP_RELE) &&
 	    ndp->ni_vp) {
Index: kern/vfs_syscalls.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_syscalls.c,v
retrieving revision 1.28
diff -u -r1.28 vfs_syscalls.c
--- kern/vfs_syscalls.c	14 Nov 2003 19:31:22 -0000	1.28
+++ kern/vfs_syscalls.c	22 Feb 2004 19:06:21 -0000
@@ -108,6 +108,8 @@
 	struct vattr va;
 	struct nameidata nd;
 	char fstypename[MFSNAMELEN];
+	lwkt_tokref vlock;
+	lwkt_tokref ilock;
 
 	if (usermount == 0 && (error = suser(td)))
 		return (error);
@@ -159,23 +161,23 @@
 			vput(vp);
 			return (error);
 		}
-		if (vfs_busy(mp, LK_NOWAIT, 0, td)) {
+		if (vfs_busy(mp, LK_NOWAIT, NULL, td)) {
 			vput(vp);
 			return (EBUSY);
 		}
-		lwkt_gettoken(&vp->v_interlock);
+		lwkt_gettoken(&vlock, vp->v_interlock);
 		if ((vp->v_flag & VMOUNT) != 0 ||
 		    vp->v_mountedhere != NULL) {
-			lwkt_reltoken(&vp->v_interlock);
+			lwkt_reltoken(&vlock);
 			vfs_unbusy(mp, td);
 			vput(vp);
 			return (EBUSY);
 		}
 		vp->v_flag |= VMOUNT;
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 		mp->mnt_flag |=
 		    SCARG(uap, flags) & (MNT_RELOAD | MNT_FORCE | MNT_UPDATE);
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 		goto update;
 	}
 	/*
@@ -230,15 +232,15 @@
 			return (ENODEV);
 		}
 	}
-	lwkt_gettoken(&vp->v_interlock);
+	lwkt_gettoken(&vlock, vp->v_interlock);
 	if ((vp->v_flag & VMOUNT) != 0 ||
 	    vp->v_mountedhere != NULL) {
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 		vput(vp);
 		return (EBUSY);
 	}
 	vp->v_flag |= VMOUNT;
-	lwkt_reltoken(&vp->v_interlock);
+	lwkt_reltoken(&vlock);
 
 	/*
 	 * Allocate and initialize the filesystem.
@@ -249,7 +251,7 @@
 	TAILQ_INIT(&mp->mnt_reservedvnlist);
 	mp->mnt_nvnodelistsize = 0;
 	lockinit(&mp->mnt_lock, 0, "vfslock", 0, LK_NOPAUSE);
-	(void)vfs_busy(mp, LK_NOWAIT, 0, td);
+	vfs_busy(mp, LK_NOWAIT, NULL, td);
 	mp->mnt_op = vfsp->vfc_vfsops;
 	mp->mnt_vfc = vfsp;
 	vfsp->vfc_refcount++;
@@ -259,7 +261,7 @@
 	mp->mnt_vnodecovered = vp;
 	mp->mnt_stat.f_owner = p->p_ucred->cr_uid;
 	mp->mnt_iosize_max = DFLTPHYS;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 update:
 	/*
 	 * Set the mount level flags.
@@ -300,36 +302,36 @@
 			mp->mnt_syncer = NULL;
 		}
 		vfs_unbusy(mp, td);
-		lwkt_gettoken(&vp->v_interlock);
+		lwkt_gettoken(&vlock, vp->v_interlock);
 		vp->v_flag &= ~VMOUNT;
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 		vrele(vp);
 		return (error);
 	}
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	/*
 	 * Put the new filesystem on the mount list after root.
 	 */
 	cache_purge(vp);
 	if (!error) {
-		lwkt_gettoken(&vp->v_interlock);
+		lwkt_gettoken(&vlock, vp->v_interlock);
 		vp->v_flag &= ~VMOUNT;
 		vp->v_mountedhere = mp;
-		lwkt_reltoken(&vp->v_interlock);
-		lwkt_gettoken(&mountlist_token);
+		lwkt_reltoken(&vlock);
+		lwkt_gettoken(&ilock, &mountlist_token);
 		TAILQ_INSERT_TAIL(&mountlist, mp, mnt_list);
-		lwkt_reltoken(&mountlist_token);
+		lwkt_reltoken(&ilock);
 		checkdirs(vp);
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 		if ((mp->mnt_flag & MNT_RDONLY) == 0)
 			error = vfs_allocate_syncvnode(mp);
 		vfs_unbusy(mp, td);
 		if ((error = VFS_START(mp, 0, td)) != 0)
 			vrele(vp);
 	} else {
-		lwkt_gettoken(&vp->v_interlock);
+		lwkt_gettoken(&vlock, vp->v_interlock);
 		vp->v_flag &= ~VMOUNT;
-		lwkt_reltoken(&vp->v_interlock);
+		lwkt_reltoken(&vlock);
 		mp->mnt_vfc->vfc_refcount--;
 		vfs_unbusy(mp, td);
 		free((caddr_t)mp, M_MOUNT);
@@ -443,10 +445,11 @@
 	struct vnode *coveredvp;
 	int error;
 	int async_flag;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(&mountlist_token);
+	lwkt_gettoken(&ilock, &mountlist_token);
 	if (mp->mnt_kern_flag & MNTK_UNMOUNT) {
-		lwkt_reltoken(&mountlist_token);
+		lwkt_reltoken(&ilock);
 		return (EBUSY);
 	}
 	mp->mnt_kern_flag |= MNTK_UNMOUNT;
@@ -454,7 +457,7 @@
 	if (flags & MNT_FORCE)
 		mp->mnt_kern_flag |= MNTK_UNMOUNTF;
 	error = lockmgr(&mp->mnt_lock, LK_DRAIN | LK_INTERLOCK |
-	    ((flags & MNT_FORCE) ? 0 : LK_NOWAIT), &mountlist_token, td);
+	    ((flags & MNT_FORCE) ? 0 : LK_NOWAIT), &ilock, td);
 	if (error) {
 		mp->mnt_kern_flag &= ~(MNTK_UNMOUNT | MNTK_UNMOUNTF);
 		if (mp->mnt_kern_flag & MNTK_MWAIT)
@@ -475,14 +478,14 @@
 	     (error = VFS_SYNC(mp, MNT_WAIT, td)) == 0) ||
 	    (flags & MNT_FORCE))
 		error = VFS_UNMOUNT(mp, flags, td);
-	lwkt_gettoken(&mountlist_token);
+	lwkt_gettokref(&ilock);
 	if (error) {
 		if ((mp->mnt_flag & MNT_RDONLY) == 0 && mp->mnt_syncer == NULL)
 			(void) vfs_allocate_syncvnode(mp);
 		mp->mnt_kern_flag &= ~(MNTK_UNMOUNT | MNTK_UNMOUNTF);
 		mp->mnt_flag |= async_flag;
 		lockmgr(&mp->mnt_lock, LK_RELEASE | LK_INTERLOCK | LK_REENABLE,
-		    &mountlist_token, td);
+		    &ilock, td);
 		if (mp->mnt_kern_flag & MNTK_MWAIT)
 			wakeup((caddr_t)mp);
 		return (error);
@@ -495,7 +498,7 @@
 	mp->mnt_vfc->vfc_refcount--;
 	if (!TAILQ_EMPTY(&mp->mnt_nvnodelist))
 		panic("unmount: dangling vnode");
-	lockmgr(&mp->mnt_lock, LK_RELEASE | LK_INTERLOCK, &mountlist_token, td);
+	lockmgr(&mp->mnt_lock, LK_RELEASE | LK_INTERLOCK, &ilock, td);
 	if (mp->mnt_kern_flag & MNTK_MWAIT)
 		wakeup((caddr_t)mp);
 	free((caddr_t)mp, M_MOUNT);
@@ -517,11 +520,12 @@
 {
 	struct thread *td = curthread;
 	struct mount *mp, *nmp;
+	lwkt_tokref ilock;
 	int asyncflag;
 
-	lwkt_gettoken(&mountlist_token);
+	lwkt_gettoken(&ilock, &mountlist_token);
 	for (mp = TAILQ_FIRST(&mountlist); mp != NULL; mp = nmp) {
-		if (vfs_busy(mp, LK_NOWAIT, &mountlist_token, td)) {
+		if (vfs_busy(mp, LK_NOWAIT, &ilock, td)) {
 			nmp = TAILQ_NEXT(mp, mnt_list);
 			continue;
 		}
@@ -532,11 +536,11 @@
 			VFS_SYNC(mp, MNT_NOWAIT, td);
 			mp->mnt_flag |= asyncflag;
 		}
-		lwkt_gettoken(&mountlist_token);
+		lwkt_gettokref(&ilock);
 		nmp = TAILQ_NEXT(mp, mnt_list);
 		vfs_unbusy(mp, td);
 	}
-	lwkt_reltoken(&mountlist_token);
+	lwkt_reltoken(&ilock);
 #if 0
 /*
  * XXX don't call vfs_bufstats() yet because that routine
@@ -693,14 +697,15 @@
 	struct mount *mp, *nmp;
 	struct statfs *sp;
 	caddr_t sfsp;
+	lwkt_tokref ilock;
 	long count, maxcount, error;
 
 	maxcount = SCARG(uap, bufsize) / sizeof(struct statfs);
 	sfsp = (caddr_t)SCARG(uap, buf);
 	count = 0;
-	lwkt_gettoken(&mountlist_token);
+	lwkt_gettoken(&ilock, &mountlist_token);
 	for (mp = TAILQ_FIRST(&mountlist); mp != NULL; mp = nmp) {
-		if (vfs_busy(mp, LK_NOWAIT, &mountlist_token, td)) {
+		if (vfs_busy(mp, LK_NOWAIT, &ilock, td)) {
 			nmp = TAILQ_NEXT(mp, mnt_list);
 			continue;
 		}
@@ -714,7 +719,7 @@
 			if (((SCARG(uap, flags) & (MNT_LAZY|MNT_NOWAIT)) == 0 ||
 			    (SCARG(uap, flags) & MNT_WAIT)) &&
 			    (error = VFS_STATFS(mp, sp, td))) {
-				lwkt_gettoken(&mountlist_token);
+				lwkt_gettokref(&ilock);
 				nmp = TAILQ_NEXT(mp, mnt_list);
 				vfs_unbusy(mp, td);
 				continue;
@@ -728,11 +733,11 @@
 			sfsp += sizeof(*sp);
 		}
 		count++;
-		lwkt_gettoken(&mountlist_token);
+		lwkt_gettokref(&ilock);
 		nmp = TAILQ_NEXT(mp, mnt_list);
 		vfs_unbusy(mp, td);
 	}
-	lwkt_reltoken(&mountlist_token);
+	lwkt_reltoken(&ilock);
 	if (sfsp && count > maxcount)
 		uap->sysmsg_result = maxcount;
 	else
@@ -761,13 +766,13 @@
 		return (error);
 	vp = (struct vnode *)fp->f_data;
 	VREF(vp);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (vp->v_type != VDIR)
 		error = ENOTDIR;
 	else
 		error = VOP_ACCESS(vp, VEXEC, p->p_ucred, td);
 	while (!error && (mp = vp->v_mountedhere) != NULL) {
-		if (vfs_busy(mp, 0, 0, td))
+		if (vfs_busy(mp, 0, NULL, td))
 			continue;
 		error = VFS_ROOT(mp, &tdp);
 		vfs_unbusy(mp, td);
@@ -780,7 +785,7 @@
 		vput(vp);
 		return (error);
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	vrele(fdp->fd_cdir);
 	fdp->fd_cdir = vp;
 	return (0);
@@ -919,7 +924,7 @@
 	if (error)
 		vput(vp);
 	else
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
@@ -997,7 +1002,7 @@
 	if (fp->f_count == 1) {
 		KASSERT(fdp->fd_ofiles[indx] != fp,
 		    ("Open file descriptor lost all refs"));
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 		vn_close(vp, flags & FMASK, td);
 		fdrop(fp, td);
 		*res = indx;
@@ -1019,7 +1024,7 @@
 		type = F_FLOCK;
 		if ((flags & FNONBLOCK) == 0)
 			type |= F_WAIT;
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 		if ((error = VOP_ADVLOCK(vp, (caddr_t)fp, F_SETLK, &lf, type)) != 0) {
 			/*
 			 * lock request failed.  Normally close the descriptor
@@ -1034,13 +1039,13 @@
 			fdrop(fp, td);
 			return (error);
 		}
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		fp->f_flag |= FHASLOCK;
 	}
 	/* assert that vn_open created a backing object if one is needed */
 	KASSERT(!vn_canvmio(vp) || VOP_GETVOBJECT(vp, NULL) == 0,
 		("open: vmio vnode has no backing object after vn_open"));
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 
 	/*
 	 * release our private reference, leaving the one associated with the
@@ -1407,7 +1412,7 @@
 		return (error);
 	vp = nd->ni_vp;
 	VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 
 	if (vp->v_type == VDIR)
 		error = EPERM;		/* POSIX */
@@ -1818,11 +1823,11 @@
 		return (error);
 
 	VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	VATTR_NULL(&vattr);
 	vattr.va_flags = flags;
 	error = VOP_SETATTR(vp, &vattr, p->p_ucred, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
@@ -1877,11 +1882,11 @@
 	struct vattr vattr;
 
 	VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	VATTR_NULL(&vattr);
 	vattr.va_mode = mode & ALLPERMS;
 	error = VOP_SETATTR(vp, &vattr, p->p_ucred, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return error;
 }
 
@@ -1969,12 +1974,12 @@
 	struct vattr vattr;
 
 	VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	VATTR_NULL(&vattr);
 	vattr.va_uid = uid;
 	vattr.va_gid = gid;
 	error = VOP_SETATTR(vp, &vattr, p->p_ucred, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return error;
 }
 
@@ -2075,14 +2080,14 @@
 	struct vattr vattr;
 
 	VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	VATTR_NULL(&vattr);
 	vattr.va_atime = ts[0];
 	vattr.va_mtime = ts[1];
 	if (nullflag)
 		vattr.va_vaflags |= VA_UTIMES_NULL;
 	error = VOP_SETATTR(vp, &vattr, p->p_ucred, td);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return error;
 }
 
@@ -2211,7 +2216,7 @@
 	vp = nd->ni_vp;
 	NDFREE(nd, NDF_ONLY_PNBUF);
 	VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (vp->v_type == VDIR)
 		error = EISDIR;
 	else if ((error = vn_writechk(vp)) == 0 &&
@@ -2261,7 +2266,7 @@
 		return (EINVAL);
 	vp = (struct vnode *)fp->f_data;
 	VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (vp->v_type == VDIR)
 		error = EISDIR;
 	else if ((error = vn_writechk(vp)) == 0) {
@@ -2269,7 +2274,7 @@
 		vattr.va_size = length;
 		error = VOP_SETATTR(vp, &vattr, fp->f_cred, td);
 	}
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
@@ -2307,14 +2312,14 @@
 	if ((error = getvnode(p->p_fd, SCARG(uap, fd), &fp)) != 0)
 		return (error);
 	vp = (struct vnode *)fp->f_data;
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if (VOP_GETVOBJECT(vp, &obj) == 0)
 		vm_object_page_clean(obj, 0, 0, 0);
 	if ((error = VOP_FSYNC(vp, MNT_WAIT, td)) == 0 &&
 	    vp->v_mount && (vp->v_mount->mnt_flag & MNT_SOFTDEP) &&
 	    bioops.io_fsync)
 		error = (*bioops.io_fsync)(vp);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
@@ -2583,12 +2588,12 @@
 	auio.uio_segflg = UIO_USERSPACE;
 	auio.uio_td = td;
 	auio.uio_resid = count;
-	/* vn_lock(vp, LK_SHARED | LK_RETRY, td); */
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	/* vn_lock(vp, NULL, LK_SHARED | LK_RETRY, td); */
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	loff = auio.uio_offset = fp->f_offset;
 	error = VOP_READDIR(vp, &auio, fp->f_cred, &eofflag, NULL, NULL);
 	fp->f_offset = auio.uio_offset;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (error)
 		return (error);
 	if (count == auio.uio_resid) {
@@ -2845,9 +2850,9 @@
 			goto bad;
 	}
 	if (fmode & O_TRUNC) {
-		VOP_UNLOCK(vp, 0, td);				/* XXX */
+		VOP_UNLOCK(vp, NULL, 0, td);			/* XXX */
 		VOP_LEASE(vp, td, p->p_ucred, LEASE_WRITE);
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);	/* XXX */
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);	/* XXX */
 		VATTR_NULL(vap);
 		vap->va_size = 0;
 		error = VOP_SETATTR(vp, vap, p->p_ucred, td);
@@ -2898,7 +2903,7 @@
 		type = F_FLOCK;
 		if ((fmode & FNONBLOCK) == 0)
 			type |= F_WAIT;
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 		if ((error = VOP_ADVLOCK(vp, (caddr_t)fp, F_SETLK, &lf, type)) != 0) {
 			/*
 			 * lock request failed.  Normally close the descriptor
@@ -2916,13 +2921,13 @@
 			fdrop(fp, td);
 			return (error);
 		}
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 		fp->f_flag |= FHASLOCK;
 	}
 	if ((vp->v_type == VREG) && (VOP_GETVOBJECT(vp, NULL) != 0))
 		vfs_object_create(vp, td);
 
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	fdrop(fp, td);
 	uap->sysmsg_result = indx;
 	return (0);
Index: kern/vfs_vnops.c
===================================================================
RCS file: /cvs/src/sys/kern/vfs_vnops.c,v
retrieving revision 1.15
diff -u -r1.15 vfs_vnops.c
--- kern/vfs_vnops.c	9 Oct 2003 22:27:19 -0000	1.15
+++ kern/vfs_vnops.c	22 Feb 2004 19:06:24 -0000
@@ -174,9 +174,9 @@
 		}
 	}
 	if (fmode & O_TRUNC) {
-		VOP_UNLOCK(vp, 0, td);				/* XXX */
+		VOP_UNLOCK(vp, NULL, 0, td);			/* XXX */
 		VOP_LEASE(vp, td, cred, LEASE_WRITE);
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);	/* XXX */
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);	/* XXX */
 		VATTR_NULL(vap);
 		vap->va_size = 0;
 		error = VOP_SETATTR(vp, vap, cred, td);
@@ -291,7 +291,7 @@
 	int error;
 
 	if ((ioflg & IO_NODELOCKED) == 0)
-		vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+		vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	auio.uio_iov = &aiov;
 	auio.uio_iovcnt = 1;
 	aiov.iov_base = base;
@@ -312,7 +312,7 @@
 		if (auio.uio_resid && error == 0)
 			error = EIO;
 	if ((ioflg & IO_NODELOCKED) == 0)
-		VOP_UNLOCK(vp, 0, td);
+		VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
@@ -380,7 +380,7 @@
 	if (fp->f_flag & O_DIRECT)
 		ioflag |= IO_DIRECT;
 	VOP_LEASE(vp, td, cred, LEASE_READ);
-	vn_lock(vp, LK_SHARED | LK_NOPAUSE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_SHARED | LK_NOPAUSE | LK_RETRY, td);
 	if ((flags & FOF_OFFSET) == 0)
 		uio->uio_offset = fp->f_offset;
 
@@ -390,7 +390,7 @@
 	if ((flags & FOF_OFFSET) == 0)
 		fp->f_offset = uio->uio_offset;
 	fp->f_nextoff = uio->uio_offset;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
@@ -425,7 +425,7 @@
 	    (vp->v_mount && (vp->v_mount->mnt_flag & MNT_SYNCHRONOUS)))
 		ioflag |= IO_SYNC;
 	VOP_LEASE(vp, td, cred, LEASE_WRITE);
-	vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	if ((flags & FOF_OFFSET) == 0)
 		uio->uio_offset = fp->f_offset;
 	ioflag |= sequential_heuristic(uio, fp);
@@ -433,7 +433,7 @@
 	if ((flags & FOF_OFFSET) == 0)
 		fp->f_offset = uio->uio_offset;
 	fp->f_nextoff = uio->uio_offset;
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (error);
 }
 
@@ -626,20 +626,23 @@
  */
 int
 #ifndef	DEBUG_LOCKS
-vn_lock(struct vnode *vp, int flags, struct thread *td)
+vn_lock(struct vnode *vp, lwkt_tokref_t vlock, int flags, struct thread *td)
 #else
-debug_vn_lock(struct vnode *vp, int flags, struct thread *td,
-		const char *filename, int line)
+debug_vn_lock(struct vnode *vp, lwkt_tokref_t vlock, int flags, 
+		struct thread *td, const char *filename, int line)
 #endif
 {
 	int error;
+	lwkt_tokref vvlock;
 	
 	do {
-		if ((flags & LK_INTERLOCK) == 0)
-			lwkt_gettoken(&vp->v_interlock);
+		if ((flags & LK_INTERLOCK) == 0) {
+			lwkt_gettoken(&vvlock, vp->v_interlock);
+			vlock = &vvlock;
+		}
 		if ((vp->v_flag & VXLOCK) && vp->v_vxproc != curproc) {
 			vp->v_flag |= VXWANT;
-			lwkt_reltoken(&vp->v_interlock);
+			lwkt_reltoken(vlock);
 			tsleep((caddr_t)vp, 0, "vn_lock", 0);
 			error = ENOENT;
 		} else {
@@ -652,7 +655,7 @@
 			vp->filename = filename;
 			vp->line = line;
 #endif
-			error = VOP_LOCK(vp,
+			error = VOP_LOCK(vp, vlock,
 				    flags | LK_NOPAUSE | LK_INTERLOCK, td);
 			if (error == 0)
 				return (error);
Index: kern/vnode_if.src
===================================================================
RCS file: /cvs/src/sys/kern/vnode_if.src,v
retrieving revision 1.5
diff -u -r1.5 vnode_if.src
--- kern/vnode_if.src	9 Oct 2003 22:27:19 -0000	1.5
+++ kern/vnode_if.src	22 Feb 2004 07:09:12 -0000
@@ -379,6 +379,7 @@
 #
 vop_lock {
 	IN struct vnode *vp;
+	IN struct lwkt_tokref *vlock;
 	IN int flags;
 	IN struct thread *td;
 };
@@ -388,6 +389,7 @@
 #
 vop_unlock {
 	IN struct vnode *vp;
+	IN struct lwkt_tokref *vlock;
 	IN int flags;
 	IN struct thread *td;
 };
Index: netproto/ncp/ncp_conn.c
===================================================================
RCS file: /cvs/src/sys/netproto/ncp/ncp_conn.c,v
retrieving revision 1.6
diff -u -r1.6 ncp_conn.c
--- netproto/ncp/ncp_conn.c	10 Nov 2003 06:12:14 -0000	1.6
+++ netproto/ncp/ncp_conn.c	22 Feb 2004 04:58:39 -0000
@@ -80,13 +80,13 @@
 int
 ncp_conn_locklist(int flags, struct thread *td)
 {
-	return lockmgr(&listlock, flags | LK_CANRECURSE, 0, td);
+	return lockmgr(&listlock, flags | LK_CANRECURSE, NULL, td);
 }
 
 void
 ncp_conn_unlocklist(struct thread *td)
 {
-	lockmgr(&listlock, LK_RELEASE, 0, td);
+	lockmgr(&listlock, LK_RELEASE, NULL, td);
 }
 
 int
@@ -110,17 +110,17 @@
 	int error;
 
 	if (conn->nc_id == 0) return EACCES;
-	error = lockmgr(&conn->nc_lock, LK_EXCLUSIVE | LK_CANRECURSE, 0, td);
+	error = lockmgr(&conn->nc_lock, LK_EXCLUSIVE | LK_CANRECURSE, NULL, td);
 	if (error == ERESTART)
 		return EINTR;
 	error = ncp_chkintr(conn, td);
 	if (error) {
-		lockmgr(&conn->nc_lock, LK_RELEASE, 0, td);
+		lockmgr(&conn->nc_lock, LK_RELEASE, NULL, td);
 		return error;
 	}
 
 	if (conn->nc_id == 0) {
-		lockmgr(&conn->nc_lock, LK_RELEASE, 0, td);
+		lockmgr(&conn->nc_lock, LK_RELEASE, NULL, td);
 		return EACCES;
 	}
 	conn->td = td;	/* who currently operates */
@@ -170,7 +170,7 @@
 	 * note, that LK_RELASE will do wakeup() instead of wakeup_one().
 	 * this will do a little overhead
 	 */
-	lockmgr(&conn->nc_lock, LK_RELEASE, 0, td);
+	lockmgr(&conn->nc_lock, LK_RELEASE, NULL, td);
 }
 
 int 
@@ -239,7 +239,7 @@
 	/*
 	 * if signal is raised - how I do react ?
 	 */
-	lockmgr(&ncp->nc_lock, LK_DRAIN, 0, ncp->td);
+	lockmgr(&ncp->nc_lock, LK_DRAIN, NULL, ncp->td);
 	while (ncp->nc_lwant) {
 		printf("lwant = %d\n", ncp->nc_lwant);
 		tsleep(&ncp->nc_lwant, 0, "ncpdr", 2*hz);
@@ -406,14 +406,14 @@
 ncp_conn_gethandle(struct ncp_conn *conn, struct thread *td, struct ncp_handle **handle){
 	struct ncp_handle *refp;
 
-	lockmgr(&lhlock, LK_EXCLUSIVE, 0, td);
+	lockmgr(&lhlock, LK_EXCLUSIVE, NULL, td);
 	SLIST_FOREACH(refp, &lhlist, nh_next)
 		if (refp->nh_conn == conn && td == refp->nh_td) break;
 	if (refp) {
 		conn->ref_cnt++;
 		refp->nh_ref++;
 		*handle = refp;
-		lockmgr(&lhlock, LK_RELEASE, 0, td);
+		lockmgr(&lhlock, LK_RELEASE, NULL, td);
 		return 0;
 	}
 	MALLOC(refp,struct ncp_handle *,sizeof(struct ncp_handle),M_NCPDATA,
@@ -425,7 +425,7 @@
 	refp->nh_id = ncp_next_handle++;
 	*handle = refp;
 	conn->ref_cnt++;
-	lockmgr(&lhlock, LK_RELEASE, 0, td);
+	lockmgr(&lhlock, LK_RELEASE, NULL, td);
 	return 0;
 }
 /*
@@ -435,7 +435,7 @@
 ncp_conn_puthandle(struct ncp_handle *handle, struct thread *td, int force) {
 	struct ncp_handle *refp = handle;
 
-	lockmgr(&lhlock, LK_EXCLUSIVE, 0, td);
+	lockmgr(&lhlock, LK_EXCLUSIVE, NULL, td);
 	refp->nh_ref--;
 	refp->nh_conn->ref_cnt--;
 	if (force) {
@@ -446,7 +446,7 @@
 		SLIST_REMOVE(&lhlist, refp, ncp_handle, nh_next);
 		FREE(refp, M_NCPDATA);
 	}
-	lockmgr(&lhlock, LK_RELEASE, 0, td);
+	lockmgr(&lhlock, LK_RELEASE, NULL, td);
 	return 0;
 }
 /*
@@ -456,10 +456,10 @@
 ncp_conn_findhandle(int connHandle, struct thread *td, struct ncp_handle **handle) {
 	struct ncp_handle *refp;
 
-	lockmgr(&lhlock, LK_SHARED, 0, td);
+	lockmgr(&lhlock, LK_SHARED, NULL, td);
 	SLIST_FOREACH(refp, &lhlist, nh_next)
 		if (refp->nh_td == td && refp->nh_id == connHandle) break;
-	lockmgr(&lhlock, LK_RELEASE, 0, td);
+	lockmgr(&lhlock, LK_RELEASE, NULL, td);
 	if (refp == NULL) {
 		return EBADF;
 	}
@@ -474,7 +474,7 @@
 	struct ncp_handle *hp, *nhp;
 	int haveone = 0;
 
-	lockmgr(&lhlock, LK_EXCLUSIVE, 0, td);
+	lockmgr(&lhlock, LK_EXCLUSIVE, NULL, td);
 	for (hp = SLIST_FIRST(&lhlist); hp; hp = nhp) {
 		nhp = SLIST_NEXT(hp, nh_next);
 		if (hp->nh_td != td) continue;
@@ -483,7 +483,7 @@
 		SLIST_REMOVE(&lhlist, hp, ncp_handle, nh_next);
 		FREE(hp, M_NCPDATA);
 	}
-	lockmgr(&lhlock, LK_RELEASE, 0, td);
+	lockmgr(&lhlock, LK_RELEASE, NULL, td);
 	return haveone;
 }
 /*
